import re
import sys
import copy

######################################
# the commandline:
# python deconvolute_ste1.py <bac_probe_file> <probe_unige_file> <output_file>
# e.g.
# python deconvolute_step1.py BAC_probe_reduced.csv pool_unigene_reduced.csv output.txt
######################################


# I will need the following tables

bac_pools = {}# a dictionary of set object indexed by bac_id
pool_bacs = {}# a dictionary of set object indexed by pool_id

pool_unigenes = {}# a dictionary of set object indexed by pool_id
unigene_pools = {}# a dictionary of set object indexed by unigene_id 

unigene_bacs = {} # a dictionary of set object indexed by unigene_id
bac_unigenes = {} # a dictionary of set object indexed by unigene_id

#the final output table
bacpool_unigenes = {}

unigenes = set()
bacs = set()
pools = set()



#read in the bac_pools file
bac_pools_file = open(sys.argv[1])
one_line = bac_pools_file.readline()
while one_line:
	split_out = one_line.strip().split(',')
	bac_pools[split_out[0]] = set(split_out[1:])
	bacs.add(split_out[0])
	one_line = bac_pools_file.readline()
bac_pools_file.close()
print 'done with read_bac_pools'


#read in the pool_unigenes file
pool_unigenes_file = open(sys.argv[2])
one_line = pool_unigenes_file.readline()
while one_line:
	split_out = one_line.strip().split(',')
	unigenes_list = split_out[1].split('|')
	pool_unigenes[split_out[0]] = set(unigenes_list)
	pools.add(split_out[0])
	unigenes = unigenes | set(unigenes_list)
	one_line = pool_unigenes_file.readline()
pool_unigenes_file.close()
print 'done with read_pool_unigenes'

#pivot the bac_pools table
for pool_id in pools:
	pool_bacs[pool_id] = set()
for bac_id in bacs:
	for pool_id in bac_pools[bac_id]:
		pool_bacs[pool_id].add(bac_id)
print 'done with bac_pools_2_pool_bacs'
			

#pivot the pool_unigenes table			
for unigene_id in unigenes:
	unigene_pools[unigene_id] = set()
for pool_id in pools:
	current_unigenes = pool_unigenes[pool_id]
	for unigene_id in current_unigenes:
		unigene_pools[unigene_id].add(pool_id)
print 'done with pool_unigenes_2_unigne_pools'

#get the unigene_bacs table
counter = 0
for unigene_id in unigenes:
	counter = counter + 1
	if counter % 100 == 0:
		print 'finished %d unigenes'%(counter)
	current_pools = unigene_pools[unigene_id]
	current_bacs = bacs
	for pool_id in current_pools:
		current_bacs = current_bacs & pool_bacs[pool_id]
	unigene_bacs[unigene_id] = current_bacs
print 'done with get_unigene_bacs'

#pivot the unigene_bacs table
for bac_id in bacs:	
	bac_unigenes[bac_id] = set()
for unigene_id in unigenes:
	current_bacs = unigene_bacs[unigene_id]
	for bac_id in current_bacs:
		bac_unigenes[bac_id].add(unigene_id)
print 'done with unigene_bacs_2_bac_unigenes'

#generate the final output
counter = 0
for bac_id in bacs:
	counter = counter + 1
	if counter % 100 == 0:
		print 'finished %d bacs'%(counter)
	for pool_id in bac_pools[bac_id]:
		current_unigene_set = pool_unigenes[pool_id] & bac_unigenes[bac_id]
		bacpool_unigenes[(bac_id,pool_id)] = current_unigene_set
print 'done with get_bacpool_unigenes'
	
output_file = open(sys.argv[3],'w')
bacpool_keys = bacpool_unigenes.keys()
bacpool_keys.sort()
for bacpool_id in bacpool_keys:
	output_file.write(bacpool_id[0])
	output_file.write(',')
	output_file.write(bacpool_id[1])
	unigenes_list = list(bacpool_unigenes[bacpool_id])
	unigenes_list.sort()
	for unigene_id in unigenes_list:
		output_file.write(',')
		output_file.write(unigene_id)
	output_file.write('\n')
