import sys
import time
import pickle

bac_2_contig_file_path = sys.argv[1]
bac_2_unigene_file_path = sys.argv[2]
lp_data_file_path = sys.argv[3]
upper_limit_on_constraint_size = int(sys.argv[4])
pickle_data_file_path = sys.argv[5]

print 'starting time:',time.time()

#the first part is to read in the bac_2_contig table 
bac_2_contig_file = open(bac_2_contig_file_path)
bac_2_contig = {}

one_line = bac_2_contig_file.readline() #expect in the format contig_id bac_id
while one_line:
	one_line = one_line.strip()
	records = one_line.split('\t')
	if len(records) <> 2 :
		print one_line
		print records
		raise "file format error"
	bac_2_contig[records[1]] = records[0]
	one_line = bac_2_contig_file.readline()
print len(bac_2_contig)
bac_2_contig_file.close()


#in the second part, read in the deconvolution by the first step of our algorithm
contig_2_unigene = []
contig_2_unigene_edges = {}
bacs = set()
bac_2_unigene_edges = set() # a set of pairs (bac_id, unigene_id)
contig_2_bacs = {} #a dictionary referenced by the contig_id
bac_2_unigene_file = open(bac_2_unigene_file_path)
one_line = bac_2_unigene_file.readline()
line_number = 0
while one_line:
	line_number = line_number + 1
	if line_number % 1000 == 0:
		print line_number
	one_line = one_line.strip()
	records = one_line.split(',')
#	print records[0],len(records)
	if (records[0] in bac_2_contig.keys()) and (len(records) > 2) and (len(records) < upper_limit_on_constraint_size):
		contig_id = bac_2_contig[records[0]]
		contig_2_unigene.append([contig_id,records[2:]])
		bacs.add(records[0])
		for unigene_id in records[2:]:
			bac_2_unigene_edges.add((records[0],unigene_id))
			
		if contig_id in contig_2_unigene_edges.keys():
			contig_2_unigene_edges[contig_id] = contig_2_unigene_edges[contig_id] | set(records[2:])
			contig_2_bacs[contig_id].add(records[0])
		else:
			contig_2_unigene_edges[contig_id] = set(records[2:])
			contig_2_bacs[contig_id] = set()
			contig_2_bacs[contig_id].add(records[0])
	one_line = bac_2_unigene_file.readline()
bac_2_unigene_file.close()

number_of_variables = 0
for key in contig_2_unigene_edges.keys():
	number_of_variables = number_of_variables + len(contig_2_unigene_edges[key])
print 'number of contigs:', len(contig_2_unigene_edges)
print 'number_of_variables:',number_of_variables
print 'number_of_constraints:',len(contig_2_unigene)
print 'finishing time:',time.time()

#part3, output the data file for the lp
unigenes_set = set()
for cc in contig_2_unigene_edges.keys():
	unigenes_set = unigenes_set | contig_2_unigene_edges[cc]
unigenes_list = list(unigenes_set)
#error checking
for uu in unigenes_list:
	if len(uu) <> len(uu.strip()):
		raise 'error in the input file'
	#try:
	#	ii = int(uu)
	#except:
	#	raise 'error in the input file'
contigs_list = list(contig_2_unigene_edges)
contigs_list.sort()
num_of_contigs = len(contig_2_unigene_edges)
num_of_unigenes = len(unigenes_list)
num_of_constraints = len(contig_2_unigene)

lp_data_file = open(lp_data_file_path,'w')
lp_data_file.write('data;\n')
lp_data_file.write('param num_of_contigs := ')
lp_data_file.write(str(num_of_contigs))
lp_data_file.write(';\n')
lp_data_file.write('param num_of_unigenes := ')
lp_data_file.write(str(num_of_unigenes))
lp_data_file.write(';\n')
lp_data_file.write('param num_of_constraints := ')
lp_data_file.write(str(num_of_constraints))
lp_data_file.write(';\n')
lp_data_file.write('set contigs:=')
for cc in contigs_list:
	lp_data_file.write(' ')
	lp_data_file.write(cc)
lp_data_file.write(';\n')
lp_data_file.write('set unigenes:=')
for uu in unigenes_list:
	lp_data_file.write(' ')
	lp_data_file.write(uu)
lp_data_file.write(';\n')
lp_data_file.write('set edges:=')
for cc in contigs_list:
	lp_data_file.write('\n('+str(cc)+',*)')
	for uu in contig_2_unigene_edges[cc]:
		lp_data_file.write(' ')
		lp_data_file.write(uu)
lp_data_file.write(';\n')
for ii in range(len(contig_2_unigene)):
	lp_data_file.write('set constraints['+str(ii+1)+'] := ('+contig_2_unigene[ii][0]+',*)')
	for uu in contig_2_unigene[ii][1]:
		lp_data_file.write(' ')
		lp_data_file.write(uu)
	lp_data_file.write(';\n')

lp_data_file.write('end;')
lp_data_file.close()

#######################################################################
#the last part is to write out the bipartite graph future rounding step
#######################################################################
#create an top_level object to be pickled
class dummy_class:
	pass
	
to_be_pickled = dummy_class()

#to_be_pickled = {}
#to_be_pickled['bacs'] = bacs # a set object
#to_be_pickled['unigenes'] = unigenes_set  # a set object 
#to_be_pickled['contigs'] = contigs_list # a list object
#to_be_pickled['contig_2_bacs'] = contig_2_bacs # a dictionary referenced by contigs
#to_be_pickled['contig_2_unigene_edges'] = contig_2_unigene_edges # a dictionary referenced by contigs
#to_be_pickled['bac_2_unigene_edges'] = bac_2_unigene_edges # a set of pairs (bac_id, unigene_id)

to_be_pickled.bacs = bacs # a set object
to_be_pickled.unigenes = unigenes_set  # a set object 
to_be_pickled.contigs = contigs_list # a list object
to_be_pickled.contig_2_bacs = contig_2_bacs # a dictionary referenced by contigs
#to_be_pickled.contig_2_unigene_edges = contig_2_unigene_edges # a dictionary referenced by contigs
to_be_pickled.bac_2_unigene_edges = bac_2_unigene_edges # a set of pairs (bac_id, unigene_id)

print 'begin to dump pickle'
pickle.dump(to_be_pickled, open(pickle_data_file_path,'w'),pickle.HIGHEST_PROTOCOL)




	